<template>
  <div v-if="isSetTimerOpened" class="relative">
    <div class="bg-white p-6 border border-grey-default rounded-md shadow-sm">
      <div class="pb-5 mb-5 border-b border-grey-default">
        <div class="w-24">
          <b-outline-action-button @click="closeTimer">
            Cancel
          </b-outline-action-button>
        </div>
      </div>
      <div class="mb-6">
        <t-span weight="bold" class="text-black-default">Time</t-span>
        <div class="flex items-center space-x-2 mt-2">
          <a-time-picker v-model="selectedStartTime" value-format="HH:mm:ss" />
          <a-time-picker v-model="selectedEndTime" value-format="HH:mm:ss" />
        </div>
      </div>
      <div class="mb-10">
        <t-span weight="bold" class="text-black-default">Date</t-span>
        <div class="flex items-center space-x-2 mt-2">
          <a-date-picker v-model="selectedDate" value-format="yyyy-MM-DD" />
        </div>
      </div>
      <b-action-button @click="onSetTime">Set time</b-action-button>
    </div>
  </div>
  <div v-else class="bg-white p-6 border border-grey-default rounded-md shadow-sm">
    <div class="mb-3 pb-3 border-b border-grey-default text-center">
      <t-p v-if="hasEndTime" weight="bold" size="text-3xl" class="text-black-default">
        {{ store.currentStartTime }} - {{ store.currentEndTime }}
      </t-p>
      <t-p v-else weight="bold" size="text-5xl" class="text-black-default">
        {{ store.currentStartTime }}
      </t-p>
      <t-p weight="medium" size="text-lg" class="text-black-light">
        {{ getDate(store.currentDate) }}
      </t-p>
    </div>
    <b-action-button v-if="hasEndTime" color="red" @click="onCancelSetTime">Back to current time</b-action-button>
    <b-action-button v-else @click="openTimer">Start set time</b-action-button>
  </div>
</template>

<script>
import { defineComponent } from '@nuxtjs/composition-api'
import moment from 'moment'
import TP from '~/components/shared/typography/Paragraph'
import BActionButton from '~/components/shared/buttons/ActionButton'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton'
import TSpan from '~/components/shared/typography/Span'
import { useBuilding } from '~/store/building'

export default defineComponent({
  components: { TSpan, BOutlineActionButton, BActionButton, TP },
  setup() {
    const store = useBuilding()
    return { store }
  },
  data() {
    return {
      selectedStartTime: null,
      selectedEndTime: null,
      selectedDate: null,
      isSetTimerOpened: false,
    }
  },
  computed: {
    hasEndTime() {
      return this.store.currentStartTime && this.store.currentEndTime && this.store.currentStartTime !== this.store.currentEndTime
    }
  },
  mounted() {
    this.store.fetchFloors(this.store.currentDate, this.store.currentStartTime, this.store.currentEndTime)
  },
  methods: {
    getDate(isoDate) {
      return moment(isoDate).format('dddd, DD MMMM yyyy')
    },
    getTime(isoDate) {
      return moment(isoDate).format('HH.mm.SS.SSS')
    },
    openTimer() {
      this.isSetTimerOpened = true
    },
    closeTimer() {
      this.isSetTimerOpened = false
    },
    onSetTime() {
      if (!(this.selectedStartTime && this.selectedEndTime && this.selectedDate)) {
        return
      }

      this.store.fetchFloors(this.selectedDate, this.selectedStartTime, this.selectedEndTime)

      this.onReset()
      this.closeTimer()
    },
    onCancelSetTime() {
      this.store.fetchFloors(this.store.lastSelectedDate, this.store.lastSelectedStartTime, this.store.lastSelectedEndTime)
    },
    onReset() {
      this.selectedDate = null
      this.selectedStartTime = null
      this.selectedEndTime = null
    },
  },
})
</script>
